
package com.rjconsultores.ventaboletos.web.utilerias;

import java.util.ArrayList;
import java.util.List;

import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zkplus.spring.SpringUtil;
import org.zkoss.zul.Combobox;

import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraService;

public class MyComboboxTipoEventoExtra extends Combobox {

	private TipoEventoExtraService tipoEventoExtraService;
	private List<TipoEventoExtra> lsTipoEventoExtra;
	private TipoEventoExtra initialValue;
	private Integer indiceSelected = null;

	public MyComboboxTipoEventoExtra() {
		super();

		tipoEventoExtraService = (TipoEventoExtraService) SpringUtil
				.getBean("tipoEventoExtraService");
		lsTipoEventoExtra = new ArrayList<TipoEventoExtra>();

		this.setAutodrop(true);
		this.setAutocomplete(true);

		this.addEventListener("onOK", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				String strTipoEventoExtra = MyComboboxTipoEventoExtra.this.getText().toUpperCase();
				if (strTipoEventoExtra.length() < MyComboboxParada.minLength) {
					return;
				}
				if (!strTipoEventoExtra.isEmpty()) {
					lsTipoEventoExtra = tipoEventoExtraService.buscarLike(strTipoEventoExtra);

					BindingListModel listModelTipoEventoExtra = new BindingListModelList(lsTipoEventoExtra,
							true);
					MyComboboxTipoEventoExtra.this.setModel(listModelTipoEventoExtra);
					indiceSelected = null;
					if (!lsTipoEventoExtra.isEmpty()) {
						indiceSelected = 0;
					}
					MyComboboxTipoEventoExtra.this.open();
				} else {
					lsTipoEventoExtra.clear();

					BindingListModel listModelTipoEventoExtra = new BindingListModelList(lsTipoEventoExtra,
							true);
					MyComboboxTipoEventoExtra.this.setModel(listModelTipoEventoExtra);
				}
			}
		});

		this.addEventListener("onChanging", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				InputEvent ev = (InputEvent) event;
				String strTipoEventoExtra = ev.getValue();
				if (strTipoEventoExtra.length() < 2) {
					lsTipoEventoExtra.clear();

					BindingListModel listModelTipoEventoExtra = new BindingListModelList(lsTipoEventoExtra,
							true);
					MyComboboxTipoEventoExtra.this.setModel(listModelTipoEventoExtra);

					MyComboboxTipoEventoExtra.this.close();
				}
			}
		});
	}

	public TipoEventoExtra getInitialValue() {
		return initialValue;
	}

	public void setInitialValue(TipoEventoExtra initialValue) {
		if (initialValue == null) {
			return;
		}
		List<TipoEventoExtra> ls = new ArrayList<TipoEventoExtra>();
		ls.add(initialValue);

		this.setModel(new BindingListModelList(ls, false));
	}

	public void getValue(boolean checaBusqueda) throws WrongValueException {
		if (checaBusqueda) {
			TipoEventoExtra tipoEventoExtra = (TipoEventoExtra) (this.getSelectedItem() == null ? null
					: this.getSelectedItem().getValue());

			if (tipoEventoExtra == null) {
				throw new WrongValueException(this, Labels.getLabel("MSG.Error.combobox.hacerBusqueda"));
			}
		} else {
			super.getValue();
		}
	}

	public <T> T getSelecteObject(Class<T> cType) {
		if (this.getSelectedItem() != null) {
			return cType.cast(this.getSelectedItem().getValue());
		}
		return null;
	}

	public Integer getIndiceSelected() {
		return indiceSelected;
	}

	public void setIndiceSelected(Integer indiceSelected) {
		this.indiceSelected = indiceSelected;
	}

}
